%global pkgname traceback2

%if 0%{?fedora} || 0%{?rhel} > 7
%bcond_without python3
%else
%bcond_with python3
%endif

Name:           python-%{pkgname}
Version:        1.4.0
Release:        3%{?dist}
Summary:        Backport of the traceback module

License:        Python
URL:            https://github.com/testing-cabal/traceback2
Source0:        https://pypi.python.org/packages/source/t/%{pkgname}/%{pkgname}-%{version}.tar.gz

BuildArch:      noarch
# Test dependencies
#BuildRequires:  python2-contextlib2
#BuildRequires:  python2-fixtures
#BuildRequires:  python2-testtools
#BuildRequires:  python2-unittest2

%if %{with python3}
BuildRequires:  python3-devel
BuildRequires:  python3-pbr
# Test dependencies
#BuildRequires:  python3-contextlib2
#BuildRequires:  python3-fixtures
#BuildRequires:  python3-testtools
#BuildRequires:  python3-unittest2
%endif # with python3

%description
A backport of traceback to older supported Pythons.

%package     -n python2-%{pkgname}
Summary:        Backport of the traceback module
BuildRequires:  python2-devel
BuildRequires:  python2-pbr
BuildRequires:  python2-linecache2
Requires:       python2-linecache2

%description -n python2-%{pkgname}
A backport of traceback to older supported Pythons.


%if %{with python3}
%package     -n python3-%{pkgname}
Summary:        Backport of the traceback module
Requires:       python3-linecache2

%description -n python3-%{pkgname}
A backport of traceback to older supported Pythons.

%endif # with python3


%prep
%setup -qc
export RHEL_ALLOW_PYTHON2_FOR_BUILD=1
mv %{pkgname}-%{version} python2
# tests shouldn't be installed
mv python2/%{pkgname}/tests .

%if %{with python3}
cp -a python2 python3
%endif # with python3


%build
export RHEL_ALLOW_PYTHON2_FOR_BUILD=1
pushd python2
%{__python2} setup.py build
popd

%if %{with python3}
pushd python3
%{__python3} setup.py build
popd
%endif # with python3


%install
export RHEL_ALLOW_PYTHON2_FOR_BUILD=1
# Must do the python3 install first because the scripts in /usr/bin are
# overwritten with every setup.py install (and we want the python2 version
# to be the default for now).
%if %{with python3}
pushd python3
%{__python3} setup.py install -O1 --skip-build --root $RPM_BUILD_ROOT
popd
%endif # with python3

pushd python2
%{__python2} setup.py install -O1 --skip-build --root $RPM_BUILD_ROOT
popd


#%check
#export RHEL_ALLOW_PYTHON2_FOR_BUILD=1
#pushd python2
#mv ../tests %{pkgname}/
#%{__python2} -m unittest2 -v
#mv %{pkgname}/tests ../
#popd
#
#%if %{with python3}
#pushd python3
#mv ../tests %{pkgname}/
## test_format_unicode_filename currently fails
#%{__python3} -m unittest2 -v || true
#mv %{pkgname}/tests ../
#popd
#%endif


%files -n python2-%{pkgname}
# license not shipped by upstream
%doc python2/AUTHORS python2/ChangeLog python2/README.rst
%{python2_sitelib}/*

%if %{with python3}
%files -n python3-%{pkgname}
%doc python3/AUTHORS python3/ChangeLog python3/README.rst
%{python3_sitelib}/*
%endif # with python3


%changelog
* Thu Dec 13 2018 Lon Hohberger <lon@redhat.com> - 1.4.0-3
- Drop tests
- Use python2-* naming
- Add RHEL8-ism

* Sat Jul 25 2015 Michel Alexandre Salim <salimma@fedoraproject.org> - 1.4.0-2
- Spec cleanup
- Fix runtime dependencies

* Wed Jul 22 2015 Michel Alexandre Salim <salimma@fedoraproject.org> - 1.4.0-1
- Initial package
